/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.Event;
import org.openapitools.client.model.EventTime;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class EventsApi {
    private ApiClient localVarApiClient;

    public EventsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public EventsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for eventsGet
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsGetCall(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/events";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (bbox != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("bbox", bbox));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (tag != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("tag", tag));
        }

        if (startMin != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("start_min", startMin));
        }

        if (startMax != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("start_max", startMax));
        }

        if (text != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("text", text));
        }

        if (createdBy != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("created_by", createdBy));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsGetValidateBeforeCall(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = eventsGetCall(bbox, limit, tag, startMin, startMax, text, createdBy, _callback);
        return localVarCall;

    }

    /**
     * Search events
     * 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @return List&lt;Event&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public List<Event> eventsGet(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy) throws ApiException {
        ApiResponse<List<Event>> localVarResp = eventsGetWithHttpInfo(bbox, limit, tag, startMin, startMax, text, createdBy);
        return localVarResp.getData();
    }

    /**
     * Search events
     * 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @return ApiResponse&lt;List&lt;Event&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<Event>> eventsGetWithHttpInfo(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy) throws ApiException {
        okhttp3.Call localVarCall = eventsGetValidateBeforeCall(bbox, limit, tag, startMin, startMax, text, createdBy, null);
        Type localVarReturnType = new TypeToken<List<Event>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search events (asynchronously)
     * 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsGetAsync(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback<List<Event>> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsGetValidateBeforeCall(bbox, limit, tag, startMin, startMax, text, createdBy, _callback);
        Type localVarReturnType = new TypeToken<List<Event>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for eventsIdDelete
     * @param id  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully deleted the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdDeleteCall(String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/events/{id}"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsIdDeleteValidateBeforeCall(String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling eventsIdDelete(Async)");
        }
        

        okhttp3.Call localVarCall = eventsIdDeleteCall(id, _callback);
        return localVarCall;

    }

    /**
     * Delete an event
     * Events can only be deleted by the organization that owns them. Ownership is determined by the event&#39;s reserved tags. 
     * @param id  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully deleted the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public void eventsIdDelete(String id) throws ApiException {
        eventsIdDeleteWithHttpInfo(id);
    }

    /**
     * Delete an event
     * Events can only be deleted by the organization that owns them. Ownership is determined by the event&#39;s reserved tags. 
     * @param id  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully deleted the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> eventsIdDeleteWithHttpInfo(String id) throws ApiException {
        okhttp3.Call localVarCall = eventsIdDeleteValidateBeforeCall(id, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Delete an event (asynchronously)
     * Events can only be deleted by the organization that owns them. Ownership is determined by the event&#39;s reserved tags. 
     * @param id  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully deleted the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdDeleteAsync(String id, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsIdDeleteValidateBeforeCall(id, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for eventsIdGet
     * @param id  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdGetCall(String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/events/{id}"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsIdGetValidateBeforeCall(String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling eventsIdGet(Async)");
        }
        

        okhttp3.Call localVarCall = eventsIdGetCall(id, _callback);
        return localVarCall;

    }

    /**
     * Get a single event
     * 
     * @param id  (required)
     * @return Event
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public Event eventsIdGet(String id) throws ApiException {
        ApiResponse<Event> localVarResp = eventsIdGetWithHttpInfo(id);
        return localVarResp.getData();
    }

    /**
     * Get a single event
     * 
     * @param id  (required)
     * @return ApiResponse&lt;Event&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Event> eventsIdGetWithHttpInfo(String id) throws ApiException {
        okhttp3.Call localVarCall = eventsIdGetValidateBeforeCall(id, null);
        Type localVarReturnType = new TypeToken<Event>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a single event (asynchronously)
     * 
     * @param id  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdGetAsync(String id, final ApiCallback<Event> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsIdGetValidateBeforeCall(id, _callback);
        Type localVarReturnType = new TypeToken<Event>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for eventsIdPut
     * @param id  (required)
     * @param event  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully updated the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdPutCall(String id, Event event, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = event;

        // create path and map variables
        String localVarPath = "/events/{id}"
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsIdPutValidateBeforeCall(String id, Event event, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling eventsIdPut(Async)");
        }
        
        // verify the required parameter 'event' is set
        if (event == null) {
            throw new ApiException("Missing the required parameter 'event' when calling eventsIdPut(Async)");
        }
        

        okhttp3.Call localVarCall = eventsIdPutCall(id, event, _callback);
        return localVarCall;

    }

    /**
     * Update an event
     * Events can only be updated by the organization that owns them. Ownership is determined by the event&#39;s reserved tags.  The updated event must be assigned at least one of the organization&#39;s reserved tags. Otherwise all reserved tags of the event are preserved by implicitly re-adding them. 
     * @param id  (required)
     * @param event  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully updated the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public void eventsIdPut(String id, Event event) throws ApiException {
        eventsIdPutWithHttpInfo(id, event);
    }

    /**
     * Update an event
     * Events can only be updated by the organization that owns them. Ownership is determined by the event&#39;s reserved tags.  The updated event must be assigned at least one of the organization&#39;s reserved tags. Otherwise all reserved tags of the event are preserved by implicitly re-adding them. 
     * @param id  (required)
     * @param event  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully updated the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> eventsIdPutWithHttpInfo(String id, Event event) throws ApiException {
        okhttp3.Call localVarCall = eventsIdPutValidateBeforeCall(id, event, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Update an event (asynchronously)
     * Events can only be updated by the organization that owns them. Ownership is determined by the event&#39;s reserved tags.  The updated event must be assigned at least one of the organization&#39;s reserved tags. Otherwise all reserved tags of the event are preserved by implicitly re-adding them. 
     * @param id  (required)
     * @param event  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Sucessfully updated the event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdPutAsync(String id, Event event, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsIdPutValidateBeforeCall(id, event, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for eventsIdsArchivePost
     * @param ids  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Archived the given events if not already archived. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdsArchivePostCall(String ids, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/events/{ids}/archive"
            .replaceAll("\\{" + "ids" + "\\}", localVarApiClient.escapeString(ids.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsIdsArchivePostValidateBeforeCall(String ids, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'ids' is set
        if (ids == null) {
            throw new ApiException("Missing the required parameter 'ids' when calling eventsIdsArchivePost(Async)");
        }
        

        okhttp3.Call localVarCall = eventsIdsArchivePostCall(ids, _callback);
        return localVarCall;

    }

    /**
     * Archive multiple events
     * Marks the given events as *archived* and excludes them from all search results.  Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Archived the given events if not already archived. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public void eventsIdsArchivePost(String ids) throws ApiException {
        eventsIdsArchivePostWithHttpInfo(ids);
    }

    /**
     * Archive multiple events
     * Marks the given events as *archived* and excludes them from all search results.  Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Archived the given events if not already archived. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> eventsIdsArchivePostWithHttpInfo(String ids) throws ApiException {
        okhttp3.Call localVarCall = eventsIdsArchivePostValidateBeforeCall(ids, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Archive multiple events (asynchronously)
     * Marks the given events as *archived* and excludes them from all search results.  Only scouts and admins are entitled to invoke this function. 
     * @param ids  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Archived the given events if not already archived. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Parameters are missing or invalid </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsIdsArchivePostAsync(String ids, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsIdsArchivePostValidateBeforeCall(ids, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for eventsPost
     * @param event  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a new event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsPostCall(Event event, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = event;

        // create path and map variables
        String localVarPath = "/events";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call eventsPostValidateBeforeCall(Event event, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'event' is set
        if (event == null) {
            throw new ApiException("Missing the required parameter 'event' when calling eventsPost(Async)");
        }
        

        okhttp3.Call localVarCall = eventsPostCall(event, _callback);
        return localVarCall;

    }

    /**
     * Create a new event
     * Creating new events is only allowed for registered organizations by authorizing themselves with an API token. These organizations must own reserved tags.  One or more reserved tags have to be provided upon creation. Otherwise all of the organization&#39;s reserved tags are added implicitly to the event. 
     * @param event  (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a new event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public String eventsPost(Event event) throws ApiException {
        ApiResponse<String> localVarResp = eventsPostWithHttpInfo(event);
        return localVarResp.getData();
    }

    /**
     * Create a new event
     * Creating new events is only allowed for registered organizations by authorizing themselves with an API token. These organizations must own reserved tags.  One or more reserved tags have to be provided upon creation. Otherwise all of the organization&#39;s reserved tags are added implicitly to the event. 
     * @param event  (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a new event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<String> eventsPostWithHttpInfo(Event event) throws ApiException {
        okhttp3.Call localVarCall = eventsPostValidateBeforeCall(event, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create a new event (asynchronously)
     * Creating new events is only allowed for registered organizations by authorizing themselves with an API token. These organizations must own reserved tags.  One or more reserved tags have to be provided upon creation. Otherwise all of the organization&#39;s reserved tags are added implicitly to the event. 
     * @param event  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 201 </td><td> Created a new event </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call eventsPostAsync(Event event, final ApiCallback<String> _callback) throws ApiException {

        okhttp3.Call localVarCall = eventsPostValidateBeforeCall(event, _callback);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
